        program hesevregx_2 
c July 28, 2000: Applying regression coefficients to brightness temperatures for
c Least Square EV retrieval of temperature , H2O, etc.
c x : EV-Tb
c y : Tem (101) ; H2o (101); Oz (101) ; Tskin (1),MW emissivity (1)
c
      implicit none

      include 'incRTVL.f'

      integer*4 nch(nb)
      integer*4 nrec,irh,noise,jx,inedt,initNoise
      integer*4 month,lenxy,initg,initgc,ix,kr,nr,j,k,n,ls
      integer*4 innt(nb),inf(nb),icld,iub,iug
      integer*4 nbeg(nb),nend(nb)                          
      integer*4 irx(nb,maxcha)
      integer*4 kcount(nl),count
      integer*4 cmask
      real*4 brt(nb,maxcha),freq(nb,maxcha),bt(nuse)
      real*4 prof(lenp),profg(lenp)
      real*4 profc(lenc)
      real*4 t(nl),w(nl),o(nl),oclim(nl),tg(nl),wg(nl),og(nl)
      real*4 freqemis(ncemis),emisir(ncemis),rhoir(ncemis)
      real*4 emisirg(ncemis),rhoirg(ncemis)
      real*4 dbdtbr(nb,maxcha),xnos(nb,maxcha),btnos(nb,maxcha)
      real*4 tsair,wsair,alat,alon,tskn,psurf,emismw,theta,cot,pc
      real*4 tskng,psurfg,pcg,cotg      
      real*4 xx,xyx,anoise,fac1,fac(nband),fme,etx,etbb,dbdtb
      character*88 brtf(nb),tigrf,brtf1,brtf2
      character*88 cldf
      character*88 nosf(nb), nosf1, nosf2
      character*88 twocoeff,inevf,gesf
      character*88 twocoeffc,inevfc

      real*8 trmsgl(ntly),wrmsgl(nwly)
      real*8 tbiasgl(ntly),wbiasgl(nwly)
      integer*4 tcountgl(ntly), wcountgl(nwly)
      real*4 tdifslab(ntly),wdifslab(nwly)
      real*4 work(nl),workg(nl)
      real*8 work8(nuse)
      real*4 xtw(nx),ytw(ny),y(ny),ytwb(ny),coeftw(nx,ny)
      real*4 vcv(nuse,nxx)

      data nbeg/1,1/
      data nend/nch1,nch2/
      data innt/20,21/,iub/40/, inf/30,31/, iug/51/, icld/52/     
      data initg/0/,initgc/0/
      data initNoise/0/

c------------------------------------------------------------------
c Namelist
c------------------------------------------------------------------
      namelist/hesevregx_2nl/nrec,brtf1,brtf2,cldf,
     &   tigrf,nosf1,nosf2,inevf,inevfc,fac1,fme,noise,inedt,
     &   irh,jx,twocoeff,twocoeffc,gesf

c------------------------------------------------------------------
c Read namelist 
c------------------------------------------------------------------
      open(1, file='hesevregx_2.nl',status='old')
      read(1, hesevregx_2nl)
      write(*, hesevregx_2nl)
      close(1)
 
      nch(1)=nch1
      nch(2)=nch2
      brtf(1)=brtf1
      brtf(2)=brtf2
      nosf(1)=nosf1
      nosf(2)=nosf2
      do n = 1,nband
        fac(n) = fac1
      enddo

      write(*,'(''  NCH:'',3i8)')nch
      write(*,'('' NUSE:'',i8)')nuse
      write(*,'(''  NXX:'',i8)')nxx
      write(*,'(''NOISE:'',i8)') noise
      write(*,'(''INEDT:'',i8)') inedt
      write(*,'(''  FAC:'',3f8.4)')fac
      write(*,'(''  FME:'',f8.4)')fme
      do n = 1,nband
        write(*,'(''   VN:'',2f8.2)')vn_start(n), vn_end(n)
      enddo

c------------------------------------------------------------------
c Open atmospheric profile file (retrieval)
c------------------------------------------------------------------
      lenxy=lenp
      open(iug,file=gesf,recl=lenxy,access='direct',
     $    status='unknown')   
      open(iub,file=tigrf,recl=lenxy,access='direct',status='old') 

c------------------------------------------------------------------
c Open brightness temperature file 
c------------------------------------------------------------------
      do n=1,nb
        lenxy=nch(n)
        open(innt(n),file=brtf(n),recl=lenxy,access='direct',
     &    status='old')
      enddo

c------------------------------------------------------------------
c Open cloud information file
c------------------------------------------------------------------
      lenxy=lenc
      open(icld,file=cldf,recl=lenxy,access='direct',
     &    status='old')

 
c------------------------------------------------------------------
c Open noise file (Binary)
c------------------------------------------------------------------
      do n = 1,nb
        lenxy=nch(n)
        open(inf(n),file=nosf(n),recl=lenxy,access='direct',
     &         status='old')
        read(inf(n),rec=1)(freq(n,k),k=1,nch(n))
        read(inf(n),rec=2)(xnos(n,k),k=1,nch(n))
        close(inf(n))
      enddo

c------------------------------------------------------------------
c Noise free -- 1e-4@250K
c------------------------------------------------------------------
      if (noise.eq.0) then
        do n = 1,nb
        do k = 1,nch(n)
          xnos(n,k) = 1.e-4
        enddo
        enddo
      endif

c------------------------------------------------------------------
c Initialize noise
c------------------------------------------------------------------
      call btNoise(nch,freq,brt,irx,xnos,dbdtbr,fac,fme,
     &  jx,inedt,btnos,initNoise)

c------------------------------------------------------------------
c Begin to read profile and Tb
c------------------------------------------------------------------
      write(*,'('' Begin to read profile and Tb'')')
            
      kr = 0
      do 1000 nr=1,nrec
        read(iub,rec=nr) prof

        call prepCube(prof,t,w,o,freqemis,emisir,rhoir,
     &    month,alat,alon,theta,psurf,tskn,emismw,ls,work)

c---------------------------------------------------------
c For geostationary satellite sounder
c---------------------------------------------------------
        if(abs(alat).gt.65.0) go to 1000
        kr = kr + 1
        tsair = t(ls)
        wsair = w(ls)

c------------------------------------------------------------------
c Read brightness temperature
c------------------------------------------------------------------
        do n=1,nb
	  read(innt(n),rec=nr) (brt(n,k),k=1,nch(n))
        enddo

c---------------------------------------------------------------------
c Adding noise to brightness temperature
c ---------------------------------------------------------------------
        call btNoise(nch,freq,brt,irx,xnos,dbdtbr,fac,fme,
     &  jx,inedt,btnos,initNoise)

c-------------------------------------------------------------------
c Put the all or selected Bands brightness temperatures into BT
c-------------------------------------------------------------------
        ix=0
        do 100 n=1,nb
          do k = nbeg(n),nend(n)
            do j=1,nband
              if(freq(n,k).ge.vn_start(j).and.
     &           freq(n,k).le.vn_end(j)) then
                ix = ix + 1
                bt(ix)=brt(n,k)+btnos(n,k)

                if(kr.eq.1) then
              write(*,
     &'(''freq;tb;xnos;irx;dbdtbr;btnos:'',3f9.3,i15,2f9.3)')
     &freq(n,k),brt(n,k),xnos(n,k),irx(n,k),dbdtbr(n,k),btnos(n,k)
                endif
  	      endif		! ENDIF for ABS spectral coverage
            enddo
          enddo
  100   continue

        if(nuse.ne.ix) then
          write(*,'('' I/O problem ; nuse;ix='',2i8)') nuse,ix
          stop
        endif

c------------------------------------------------------------------
c Read cloud information
c------------------------------------------------------------------
        read(icld,rec=nr) (profc(k),k=1,lenc)
        call parseCubeCloud(profc,alat,alon,pc,cot)

c------------------------------------------------------------------
c Retrieve cloudy + clear sky 
c------------------------------------------------------------------
c
c
c------------------------------------------------------------------
c Get EV regression retrieval
c------------------------------------------------------------------
        if (cot .ne. 0) then     ! cot=0 clear,  cot=1 ice cloud,  cot=2 water cloud
CCCC ******* cloudy sky  *****************************
        print *, nr, 'cldy', initg, initgc,pc
        call evregc(twocoeffc,inevfc,bt,tsair,wsair,psurf,theta,
     &       alat,tg,wg,og,tskng,psurfg,emisirg,rhoirg,pcg,cotg,
     &       work8,xtw,ytw,y,ytwb,coeftw,vcv,initgc)
        if(kr.le.3) then
          write(*,
     &        '('' pressure TRUE-T RTV-T TRUE-W RTV-W TRUE O RTV O'')')
          do j=1,ls
            write(*,'(1x,f8.2,6f10.3)')p(j),t(j),tg(j),w(j),
     &                                   wg(j),o(j),og(j)
          enddo
          write(*,'('' kr ; True ; RTVL Tskin :'',i9,4f8.2)')
     &              kr,tskn,tskng,psurf,psurfg
        endif     
CCCC ****** END of cloudy sky ***********************
        else
CCCC ******* clear sky   *****************************
        print *, nr, 'clear', initg, initgc,pc
        call evreg(twocoeff,inevf,bt,tsair,wsair,psurf,theta,alat,
     &       tg,wg,og,tskng,psurfg,emisirg,rhoirg,pcg,cotg,
     &       work8,xtw,ytw,y,ytwb,coeftw,vcv,initg)
        if(kr.le.3) then
          write(*,
     &        '('' pressure TRUE-T RTV-T TRUE-W RTV-W TRUE O RTV O'')')
          do j=1,ls
            write(*,'(1x,f8.2,6f10.3)')p(j),t(j),tg(j),w(j),
     &                                   wg(j),o(j),og(j) 
          enddo
          write(*,'('' kr ; True ; RTVL Tskin :'',i9,4f8.2)')
     &              kr,tskn,tskng,psurf,psurfg
        endif
        endif
CCCC ****** END of clear sky *********************** 
	
	call renewProf(prof,profg,tg,wg,og,tskng,psurfg,pcg,cotg,ls)
        write(iug,rec=nr) (profg(j),j=1,lenp)	
	
        	
 1000 continue
      
      nr = nr - 1
      write(*,'('' TOTAL PROFILES:'',i7)')nr
      write(*,'('' TOTAL RETRIEVALS:'',i7)')kr      


      do n = 1,nb
        close(innt(n))
      enddo
      close(icld)
      close(iub)
      close(iug)

      stop
      end
